'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _function = require('react-pure-render/function');

var _function2 = _interopRequireDefault(_function);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

var _dateRange = require('material-ui/svg-icons/action/date-range');

var _dateRange2 = _interopRequireDefault(_dateRange);

var _List = require('material-ui/List');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _modeEdit = require('material-ui/svg-icons/editor/mode-edit');

var _modeEdit2 = _interopRequireDefault(_modeEdit);

var _Popover = require('material-ui/Popover');

var _reactDateRange = require('react-date-range');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _show_all_button = require('./show_all_button');

var _show_all_button2 = _interopRequireDefault(_show_all_button);

var _text_helpers = require('../util/text_helpers');

var _styles = require('../styles');

var _config = require('../../config.json');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PureDateRange = (0, _pure2.default)(_reactDateRange.DateRange);

var styles = {
  nestedList: {
    paddingTop: 0,
    paddingBottom: 0
  },
  dateItem: {
    marginLeft: 0,
    padding: '16px 56px 16px 16px',
    position: 'relative',
    fontSize: 14,
    lineHeight: '14px',
    color: 'rgba(0, 0, 0, 0.870588)'
  },
  iconButton: {
    padding: 12,
    width: 46,
    height: 46,
    top: 0,
    right: 4,
    background: 'none',
    position: 'absolute'
  },
  editIcon: {
    width: 20,
    height: 20
  },
  showAll: {
    fontSize: 12,
    lineHeight: '16px',
    height: 16,
    margin: '4px 0px 0px',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap'
  }
};

// Material-ui passes a `nestedLevel` prop to nested items.
// We're not using a `div` instead of the material-ui component for
// nested items, so we need to remove the `nestedLevel` prop.
var NestedItem = function NestedItem(props) {
  var divProps = (0, _omit2.default)(props, ['nestedLevel', 'children']);
  return _react2.default.createElement(
    'div',
    divProps,
    props.children
  );
};

var DateFilter = function (_React$Component) {
  (0, _inherits3.default)(DateFilter, _React$Component);

  function DateFilter() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DateFilter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DateFilter.__proto__ || (0, _getPrototypeOf2.default)(DateFilter)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _this.shouldComponentUpdate = _function2.default, _this.showDatePopover = function (event) {
      // This prevents ghost click.
      var target = _this.refs.dateRange;
      event.preventDefault();
      var range = document.createRange();
      var sel = window.getSelection();
      range.selectNodeContents(target);
      sel.removeAllRanges();
      sel.addRange(range);
      _this.setState({
        open: true,
        anchorEl: target
      });
    }, _this.handleNestedListToggle = function (e) {
      _this.setState({
        expanded: !_this.state.expanded
      });
    }, _this.showAllDates = function (e) {
      e.preventDefault();
      _this.handleDateChange({
        startDate: _this.props.valueMin,
        endDate: _this.props.valueMax
      });
    }, _this.handleDateChange = function (e) {
      if (e.startDate !== _this.props.startDate) {
        _this.props.onUpdate({
          exp: '>=',
          key: _this.props.fieldName,
          val: +e.startDate
        });
      }
      if (e.endDate !== _this.props.endDate) {
        _this.props.onUpdate({
          exp: '<=',
          key: _this.props.fieldName,
          val: +e.endDate
        });
      }
    }, _this.handleRequestClose = function () {
      _this.setState({
        open: false
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DateFilter, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({
        el: (0, _reactDom.findDOMNode)(this.refs.dateItem)
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          fieldName = _props.fieldName,
          min = _props.min,
          max = _props.max,
          valueMin = _props.valueMin,
          valueMax = _props.valueMax;

      var isFiltered = min > valueMin || max < valueMax;
      var minMoment = (0, _moment2.default)(min);
      var maxMoment = (0, _moment2.default)(max);
      var rangeStr = minMoment.format(_config.dateFormatShort) + ' — ' + maxMoment.format(_config.dateFormatShort);
      return _react2.default.createElement(_List.ListItem, {
        innerDivStyle: _styles.listStyles.listItemInner,
        primaryText: (0, _text_helpers.titleCase)(fieldName),
        leftIcon: _react2.default.createElement(_dateRange2.default, { style: _styles.listStyles.listIcon }),
        initiallyOpen: true,
        rightIconButton: isFiltered ? _react2.default.createElement(_show_all_button2.default, { onTouchTap: this.showAllDates }) : null,
        disabled: true,
        ref: 'dateItem',
        nestedItems: [_react2.default.createElement(
          NestedItem,
          { style: styles.dateItem, key: 'dateItem' },
          _react2.default.createElement(
            'div',
            { ref: 'dateRange', onClick: this.showDatePopover },
            rangeStr
          ),
          _react2.default.createElement(
            _IconButton2.default,
            {
              onTouchTap: this.showDatePopover,
              tooltip: 'Select dates',
              style: styles.iconButton,
              iconStyle: styles.editIcon,
              tooltipPosition: 'bottom-left' },
            _react2.default.createElement(_modeEdit2.default, { color: '#757575' })
          ),
          _react2.default.createElement(
            _Popover.Popover,
            {
              open: this.state.open,
              anchorEl: this.state.el,
              anchorOrigin: { horizontal: 'left', vertical: 'bottom' },
              targetOrigin: { horizontal: 'left', vertical: 'top' },
              onRequestClose: this.handleRequestClose,
              animation: _Popover.PopoverAnimationVertical
            },
            _react2.default.createElement(PureDateRange, {
              startDate: minMoment,
              endDate: maxMoment,
              onChange: this.handleDateChange })
          )
        )]
      });
    }
  }]);
  return DateFilter;
}(_react2.default.Component);

DateFilter.propTypes = {
  fieldName: _react.PropTypes.string.isRequired,
  onUpdate: _react.PropTypes.func
};
exports.default = DateFilter;