'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _function = require('react-pure-render/function');

var _function2 = _interopRequireDefault(_function);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

var _Checkbox = require('material-ui/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _list = require('material-ui/svg-icons/action/list');

var _list2 = _interopRequireDefault(_list);

var _List = require('material-ui/List');

var _reactIntl = require('react-intl');

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _show_all_button = require('./show_all_button');

var _show_all_button2 = _interopRequireDefault(_show_all_button);

var _only_button = require('./only_button');

var _only_button2 = _interopRequireDefault(_only_button);

var _intl_helpers = require('../util/intl_helpers');

var _styles = require('../styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PureCheckbox = (0, _pure2.default)(_Checkbox2.default);

var styles = {
  checkbox: {
    marginBottom: 8,
    fontSize: 14
  },
  checkboxLabel: {
    lineHeight: '22px',
    whiteSpace: 'nowrap',
    overflow: 'hidden',
    textOverflow: 'ellipsis'
  },
  checkboxIcon: {
    width: 20,
    height: 20,
    marginRight: 14
  }
};

// Material-ui passes a `nestedLevel` prop to nested items.
// We're not using a `div` instead of the material-ui component for
// nested items, so we need to remove the `nestedLevel` prop.
var NestedItem = function NestedItem(props) {
  var divProps = (0, _omit2.default)(props, ['nestedLevel', 'children']);
  return _react2.default.createElement(
    'div',
    divProps,
    props.children
  );
};

var DiscreteFilter = function (_React$Component) {
  (0, _inherits3.default)(DiscreteFilter, _React$Component);

  function DiscreteFilter() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DiscreteFilter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DiscreteFilter.__proto__ || (0, _getPrototypeOf2.default)(DiscreteFilter)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _this.shouldComponentUpdate = _function2.default, _this.showAll = function (e) {
      e.preventDefault();
      _this.props.onUpdate({
        exp: 'in',
        key: _this.props.fieldName,
        val: null
      });
    }, _this.handleCheck = function (e) {
      var v = e.target.value;
      var checked = _this.props.checked.slice(0);
      if (e.target.checked && checked.indexOf(v) === -1) {
        checked.push(v);
      } else if (!e.target.checked && checked.indexOf(v) > -1) {
        checked.splice(checked.indexOf(v), 1);
      }
      _this.props.onUpdate({
        exp: 'in',
        key: _this.props.fieldName,
        val: checked
      });
    }, _this.handleMouseLeave = function () {
      _this.setState({ hovered: false });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DiscreteFilter, [{
    key: 'handleOnlyClick',
    value: function handleOnlyClick(key, e) {
      e.preventDefault();
      this.props.onUpdate({
        exp: 'in',
        key: this.props.fieldName,
        val: [key]
      });
    }
  }, {
    key: 'handleMouseEnter',
    value: function handleMouseEnter(key) {
      this.setState({ hovered: key });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          fieldName = _props.fieldName,
          checked = _props.checked,
          values = _props.values;

      var isFiltered = checked.length < (0, _keys2.default)(values).length;
      return _react2.default.createElement(_List.ListItem, {
        innerDivStyle: _styles.listStyles.listItemInner,
        primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_key')(fieldName)),
        leftIcon: _react2.default.createElement(_list2.default, { style: _styles.listStyles.listIcon }),
        initiallyOpen: true,
        disabled: true,
        rightIconButton: isFiltered ? _react2.default.createElement(_show_all_button2.default, { onTouchTap: this.showAll }) : null,
        nestedListStyle: _styles.listStyles.nestedList,
        nestedItems: (0, _keys2.default)(values).map(function (v) {
          return _react2.default.createElement(
            NestedItem,
            {
              key: v,
              style: { position: 'relative' },
              onMouseEnter: _this2.handleMouseEnter.bind(_this2, v),
              onMouseLeave: _this2.handleMouseLeave },
            _react2.default.createElement(PureCheckbox, {
              label: _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_value')(v)),
              title: _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_value')(v)),
              value: v,
              style: styles.checkbox,
              iconStyle: styles.checkboxIcon,
              labelStyle: styles.checkboxLabel,
              checked: checked.indexOf(v) > -1,
              onCheck: _this2.handleCheck,
              disableFocusRipple: true,
              disableTouchRipple: true }),
            _this2.state.hovered === v && _react2.default.createElement(_only_button2.default, {
              onTouchTap: _this2.handleOnlyClick.bind(_this2, v) })
          );
        })
      });
    }
  }]);
  return DiscreteFilter;
}(_react2.default.Component);

DiscreteFilter.propTypes = {
  fieldName: _react.PropTypes.string.isRequired,
  checked: _react.PropTypes.array,
  values: _react.PropTypes.objectOf(_react.PropTypes.number),
  onUpdate: _react.PropTypes.func
};
DiscreteFilter.defaultProps = {
  checked: [],
  onUpdate: function onUpdate(x) {
    return x;
  }
};
exports.default = DiscreteFilter;