'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Table = require('material-ui/Table');

var _reactIntl = require('react-intl');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _intl_helpers = require('../util/intl_helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  firstColumn: {
    fontWeight: 'bold'
  },
  smallRow: {
    height: 36
  }
};

var FeatureTable = function (_React$Component) {
  (0, _inherits3.default)(FeatureTable, _React$Component);

  function FeatureTable() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FeatureTable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FeatureTable.__proto__ || (0, _getPrototypeOf2.default)(FeatureTable)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      width: '50%'
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(FeatureTable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.autoFitColumn();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (this.props.data !== prevProps.data) {
        this.autoFitColumn();
      }
    }
  }, {
    key: 'autoFitColumn',
    value: function autoFitColumn() {
      var _this2 = this;

      var width = 0;
      this.props.data.forEach(function (row) {
        var rowEl = _reactDom2.default.findDOMNode(_this2.refs[row.key]);
        width = Math.max(width, rowEl.offsetWidth);
      });
      this.setState({
        width: width
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          data = _props.data,
          print = _props.print;

      var rowColStyle = (0, _objectAssign2.default)({}, styles.firstColumn, { width: this.state.width });
      if (print) (0, _objectAssign2.default)(rowColStyle, styles.smallRow);
      return _react2.default.createElement(
        _Table.Table,
        { selectable: false },
        _react2.default.createElement(
          _Table.TableBody,
          { displayRowCheckbox: false, preScanRows: false },
          data.map(function (row, i) {
            return _react2.default.createElement(
              _Table.TableRow,
              { key: row.key, style: print && styles.smallRow },
              _react2.default.createElement(
                _Table.TableRowColumn,
                { ref: '__td' + i, style: rowColStyle },
                _react2.default.createElement(
                  'span',
                  { ref: row.key },
                  _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_key')(row.key))
                )
              ),
              _react2.default.createElement(
                _Table.TableRowColumn,
                { style: styles.smallRow },
                _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_value')(row.value))
              )
            );
          })
        )
      );
    }
  }]);
  return FeatureTable;
}(_react2.default.Component);

FeatureTable.defaultProps = {
  data: []
};
exports.default = FeatureTable;