'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _Card = require('material-ui/Card');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _close = require('material-ui/svg-icons/navigation/close');

var _close2 = _interopRequireDefault(_close);

var _List = require('material-ui/List');

var _Toggle = require('material-ui/Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

var _reactIntl = require('react-intl');

var _filterable_fields = require('../selectors/filterable_fields');

var _filterable_fields2 = _interopRequireDefault(_filterable_fields);

var _visible_filters = require('../selectors/visible_filters');

var _visible_filters2 = _interopRequireDefault(_visible_filters);

var _action_creators = require('../action_creators');

var _intl_helpers = require('../util/intl_helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PropTypes = _react2.default.PropTypes;


var styles = {
  card: {
    maxHeight: '100%',
    width: '100%',
    flex: 1,
    display: 'flex',
    flexDirection: 'column'
  },
  cardContainerStyle: {
    flex: 1,
    flexDirection: 'column',
    display: 'flex'
  },
  header: {
    lineHeight: '22px',
    boxSizing: 'content-box',
    borderBottom: '1px solid #cccccc'
  },
  icon: {
    float: 'right'
  },
  scrollable: {
    overflow: 'auto'
  }
};

var messages = (0, _reactIntl.defineMessages)({
  configureFilters: {
    'id': 'filter.configure',
    'defaultMessage': 'Configure Filters'
  }
});

var FilterConfigurator = function (_React$Component) {
  (0, _inherits3.default)(FilterConfigurator, _React$Component);

  function FilterConfigurator() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, FilterConfigurator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = FilterConfigurator.__proto__ || (0, _getPrototypeOf2.default)(FilterConfigurator)).call.apply(_ref, [this].concat(args))), _this), _this.onToggle = function (fieldName) {
      var _this$props = _this.props,
          onRemoveFilter = _this$props.onRemoveFilter,
          onUpdateVisibleFilters = _this$props.onUpdateVisibleFilters,
          visibleFilters = _this$props.visibleFilters;

      return function (_ref2) {
        var target = _ref2.target;

        var newVisibleFilters = void 0;

        if (target.checked) {
          newVisibleFilters = [].concat((0, _toConsumableArray3.default)(visibleFilters), [fieldName]);
        } else {
          var index = visibleFilters.indexOf(fieldName);
          newVisibleFilters = [].concat((0, _toConsumableArray3.default)(visibleFilters.slice(0, index)), (0, _toConsumableArray3.default)(visibleFilters.slice(index + 1)));

          onRemoveFilter(fieldName);
        }

        onUpdateVisibleFilters(newVisibleFilters);
      };
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(FilterConfigurator, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          filterableFields = _props.filterableFields,
          onCloseClick = _props.onCloseClick,
          visibleFilters = _props.visibleFilters;


      return _react2.default.createElement(
        _Card.Card,
        {
          style: styles.card,
          containerStyle: styles.cardContainerStyle,
          zDepth: 2 },
        _react2.default.createElement(
          _Card.CardHeader,
          {
            style: styles.header,
            title: _react2.default.createElement(
              'h3',
              { style: styles.title },
              _react2.default.createElement(_reactIntl.FormattedMessage, messages.configureFilters)
            ) },
          _react2.default.createElement(
            _IconButton2.default,
            { style: styles.icon, onTouchTap: onCloseClick },
            _react2.default.createElement(_close2.default, null)
          )
        ),
        _react2.default.createElement(
          _Card.CardText,
          { style: styles.scrollable },
          _react2.default.createElement(
            _List.List,
            null,
            filterableFields.map(function (field) {
              return _react2.default.createElement(_List.ListItem, {
                key: field,
                primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_key')(field)),
                rightToggle: _react2.default.createElement(_Toggle2.default, {
                  toggled: visibleFilters.includes(field),
                  onToggle: _this2.onToggle(field)
                })
              });
            })
          )
        )
      );
    }
  }]);
  return FilterConfigurator;
}(_react2.default.Component);

FilterConfigurator.propTypes = {
  filterableFields: PropTypes.array.isRequired,
  onCloseClick: PropTypes.func.isRequired,
  onRemoveFilter: PropTypes.func.isRequired,
  onUpdateVisibleFilters: PropTypes.func.isRequired,
  visibleFilters: PropTypes.array.isRequired
};


function mapStateToProps(state) {
  return {
    filterableFields: (0, _filterable_fields2.default)(state),
    visibleFilters: (0, _visible_filters2.default)(state)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    onRemoveFilter: function onRemoveFilter(filter) {
      return dispatch((0, _action_creators.removeFilter)(filter));
    },
    onUpdateVisibleFilters: function onUpdateVisibleFilters(filters) {
      return dispatch((0, _action_creators.updateVisibleFilters)(filters));
    }
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FilterConfigurator);