'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactImageloader = require('react-imageloader');

var _reactImageloader2 = _interopRequireDefault(_reactImageloader);

var _CircularProgress = require('material-ui/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _brokenImage = require('material-ui/svg-icons/image/broken-image');

var _brokenImage2 = _interopRequireDefault(_brokenImage);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactRedux = require('react-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  wrapper: {
    width: '100%',
    height: '100%',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center'
  }
};

var pixelRatio = window.devicePixelRatio || 1;

var createDiv = _react2.default.createElement.bind(null, 'div');

var Image = function (_React$Component) {
  (0, _inherits3.default)(Image, _React$Component);

  function Image() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Image);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Image.__proto__ || (0, _getPrototypeOf2.default)(Image)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Image, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          src = _props.src,
          resizer = _props.resizer;

      var mediaSrc = src;

      if (resizer) {
        var el = _reactDom2.default.findDOMNode(this);
        var size = roundUp(Math.max(el.offsetWidth, el.offsetHeight) * pixelRatio);
        mediaSrc = resizer.replace('{width}', size).replace('{height}', size).replace('{url}', src);
      }

      this.setState({
        src: mediaSrc,
        loadStart: Date.now()
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // TODO: whitelist, not blacklist
      var props = (0, _omit2.default)(this.props, ['progress', 'src', 'style', 'resizer', 'dispatch']);
      var style = this.props.style;


      return _react2.default.createElement(_reactImageloader2.default, {
        imgProps: (0, _objectAssign2.default)({}, props, { style: style }),
        src: this.state.src,
        style: (0, _objectAssign2.default)({}, styles.wrapper, style),
        preloader: function preloader() {
          return _react2.default.createElement(
            'div',
            { style: styles.wrapper },
            _react2.default.createElement(_CircularProgress2.default, null)
          );
        },
        wrapper: function wrapper(props, element) {
          var loadTime = Date.now() - _this2.state.loadStart;
          if (!element) {
            return _react2.default.createElement(
              'div',
              { style: styles.wrapper },
              _react2.default.createElement(_brokenImage2.default, { color: 'grey' })
            );
          } else if (element.type !== 'img' || loadTime < 200) {
            // Only fade in if image takes more than 200ms to load
            return createDiv(props, element);
          } else {
            var mergedProps = (0, _objectAssign2.default)({}, props, {
              className: 'fadeIn'
            });
            return createDiv(mergedProps, element);
          }
        }
      });
    }
  }]);
  return Image;
}(_react2.default.Component);

exports.default = (0, _reactRedux.connect)(function (state) {
  return { resizer: state.resizer };
})(Image);


function roundUp(v) {
  return Math.ceil(v / 50) * 50;
}