'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Card = require('material-ui/Card');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  card: {
    width: '100%',
    height: '100%',
    flex: 1,
    display: 'flex',
    flexDirection: 'column'
  },
  cardContainerStyle: {
    flex: 1,
    flexDirection: 'column',
    display: 'flex'
  },
  header: {
    lineHeight: '22px',
    boxSizing: 'content-box',
    borderBottom: '1px solid #cccccc'
  },
  markerIcon: {
    width: 40,
    height: 40,
    margin: 0,
    marginRight: 16
  },
  scrollable: {
    flex: 1,
    overflow: 'auto'
  },
  media: {
    position: 'relative',
    height: 0,
    padding: '67% 0 0 0'
  },
  img: {
    width: '100%',
    height: '100%',
    top: 0,
    left: 0,
    position: 'absolute',
    objectFit: 'cover'
  }
};

var Report = function Report(_ref) {
  var color = _ref.color,
      media = _ref.media,
      data = _ref.data,
      title = _ref.title,
      subtitle = _ref.subtitle,
      onCloseClick = _ref.onCloseClick;
  return _react2.default.createElement(
    _Card.Card,
    {
      style: styles.card,
      containerStyle: styles.cardContainerStyle,
      zDepth: 2 },
    _react2.default.createElement(
      _Card.CardHeader,
      {
        style: styles.header,
        avatar: _react2.default.createElement(MarkerIcon, { color: color, style: styles.markerIcon }),
        title: _react2.default.createElement(FormattedMessage, msg('field_value')(title)),
        subtitle: _react2.default.createElement(FormattedMessage, msg('field_value')(subtitle)) },
      _react2.default.createElement(
        IconButton,
        { style: { float: 'right' }, onTouchTap: onCloseClick },
        _react2.default.createElement(CloseIcon, null)
      )
    ),
    _react2.default.createElement(
      'div',
      { style: styles.scrollable },
      _react2.default.createElement(
        _Card.CardMedia,
        { style: styles.media },
        _react2.default.createElement(Image, { style: styles.img, src: media })
      ),
      _react2.default.createElement(
        _Card.CardText,
        null,
        _react2.default.createElement(FeatureTable, { data: data })
      )
    )
  );
};

exports.default = Report;