'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reactDom = require('react-dom');

var _Card = require('material-ui/Card');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _close = require('material-ui/svg-icons/navigation/close');

var _close2 = _interopRequireDefault(_close);

var _CircularProgress = require('material-ui/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _checkCircle = require('material-ui/svg-icons/action/check-circle');

var _checkCircle2 = _interopRequireDefault(_checkCircle);

var _RaisedButton = require('material-ui/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _Snackbar = require('material-ui/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

var _warning = require('material-ui/svg-icons/alert/warning');

var _warning2 = _interopRequireDefault(_warning);

var _List = require('material-ui/List');

var _Subheader = require('material-ui/Subheader');

var _Subheader2 = _interopRequireDefault(_Subheader);

var _colors = require('material-ui/styles/colors');

var _colors2 = _interopRequireDefault(_colors);

var _reactIntl = require('react-intl');

var _dragDrop = require('drag-drop');

var _dragDrop2 = _interopRequireDefault(_dragDrop);

var _xformUploader = require('xform-uploader');

var _xformUploader2 = _interopRequireDefault(_xformUploader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PropTypes = _react2.default.PropTypes;

require('insert-css')('.drag div.upload{background-color:#CFD8DC !important;}');

var noop = function noop() {
  return null;
};

var styles = {
  card: {
    maxHeight: '100%',
    width: '100%',
    flex: 1,
    display: 'flex',
    flexDirection: 'column'
  },
  cardContainerStyle: {
    flex: 1,
    flexDirection: 'column',
    display: 'flex'
  },
  cardText: {
    overflow: 'auto'
  },
  header: {
    lineHeight: '22px',
    boxSizing: 'content-box',
    borderBottom: '1px solid #cccccc'
  },
  uploadBox: {
    backgroundColor: '#eee',
    border: '2px dashed #aaa',
    color: '#ccc',
    fontWeight: 'bold',
    fontSize: '46px',
    padding: '25px',
    textAlign: 'center'
  }
};

var messages = (0, _reactIntl.defineMessages)({
  dragHere: {
    'id': 'upload.dragHere',
    'defaultMessage': 'DRAG HERE'
  },
  pendingForms: {
    'id': 'upload.pendingForms',
    'defaultMessage': 'Forms'
  },
  missingAttachments: {
    'id': 'upload.missingAttachments',
    'defaultMessage': 'Missing Attachments'
  },
  upload: {
    'id': 'upload.upload',
    'defaultMessage': 'Upload'
  },
  uploadFormData: {
    'id': 'upload.uploadFormData',
    'defaultMessage': 'Add Form Data'
  }
});

var UploadFormDataModal = function (_React$Component) {
  (0, _inherits3.default)(UploadFormDataModal, _React$Component);

  function UploadFormDataModal() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, UploadFormDataModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = UploadFormDataModal.__proto__ || (0, _getPrototypeOf2.default)(UploadFormDataModal)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      forms: [],
      missingAttachments: [],
      orphanAttachments: [],
      showSnackbar: false,
      snackbarMessage: 'Forms uploaded.',
      uploading: false
    }, _this.uploadForms = function () {
      var _this$props = _this.props,
          mediaUrl = _this$props.mediaUrl,
          observationsUrl = _this$props.observationsUrl;

      // trigger progress spinner

      _this.setState({
        uploading: true
      });

      _this.uploader.upload({
        mediaUrl: mediaUrl,
        observationsUrl: observationsUrl
      }, function (err) {
        _this.setState({
          uploading: false
        });

        // cancel progress spinner
        if (err) {
          return console.warn(err.stack);
        }

        _this.setState({
          showSnackbar: true
        });

        _this.resetUploader();
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(UploadFormDataModal, [{
    key: 'resetUploader',
    value: function resetUploader() {
      var _this2 = this;

      this.uploader = new _xformUploader2.default();

      this.uploader.on('change', function () {
        _this2.setState(_this2.uploader.state());
      });

      this.setState(this.uploader.state());
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      this.resetUploader();

      this.removeDragDrop = (0, _dragDrop2.default)((0, _reactDom.findDOMNode)(this.uploadContainer), function (files) {
        _this3.uploader.add(files, function (err) {
          if (err) {
            console.warn(err.stack);
          }
        });
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeDragDrop();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var onCloseClick = this.props.onCloseClick;
      var _state = this.state,
          forms = _state.forms,
          showSnackbar = _state.showSnackbar,
          snackbarMessage = _state.snackbarMessage,
          uploading = _state.uploading;


      return _react2.default.createElement(
        _Card.Card,
        {
          style: styles.card,
          containerStyle: styles.cardContainerStyle,
          zDepth: 2 },
        _react2.default.createElement(
          _Card.CardHeader,
          {
            style: styles.header,
            title: _react2.default.createElement(
              'h3',
              { style: styles.title },
              _react2.default.createElement(_reactIntl.FormattedMessage, messages.uploadFormData)
            ) },
          _react2.default.createElement(
            _IconButton2.default,
            { style: { float: 'right' }, onTouchTap: onCloseClick },
            _react2.default.createElement(_close2.default, null)
          )
        ),
        _react2.default.createElement(
          _Card.CardText,
          { ref: function ref(el) {
              return _this4.uploadContainer = el;
            }, style: styles.cardText },
          _react2.default.createElement(
            'div',
            { className: 'upload', style: styles.uploadBox },
            _react2.default.createElement(_reactIntl.FormattedMessage, messages.dragHere)
          ),
          forms.length > 0 && _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _List.List,
              null,
              _react2.default.createElement(
                _Subheader2.default,
                null,
                _react2.default.createElement(_reactIntl.FormattedMessage, messages.pendingForms)
              ),
              forms.map(function (form, idx) {
                return _react2.default.createElement(_List.ListItem, {
                  key: idx,
                  primaryText: _react2.default.createElement(
                    'code',
                    null,
                    form.name
                  ),
                  leftIcon: form.missingAttachments.length ? _react2.default.createElement(_warning2.default, { color: _colors2.default.orange500 }) : _react2.default.createElement(_checkCircle2.default, { color: _colors2.default.green500 }),
                  nestedItems: form.missingAttachments.map(function (a, jdx) {
                    return _react2.default.createElement(_List.ListItem, {
                      key: jdx,
                      primaryText: _react2.default.createElement(
                        'span',
                        null,
                        'Missing ',
                        _react2.default.createElement(
                          'code',
                          null,
                          a
                        )
                      )
                    });
                  })
                });
              })
            ),
            _react2.default.createElement(_RaisedButton2.default, {
              icon: uploading ? _react2.default.createElement(_CircularProgress2.default, { size: 20, thickness: 2.5 }) : null,
              label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.upload),
              onTouchTap: uploading ? noop : this.uploadForms,
              primary: true })
          )
        ),
        _react2.default.createElement(_Snackbar2.default, {
          open: showSnackbar,
          message: snackbarMessage,
          autoHideDuration: 4000
        })
      );
    }
  }]);
  return UploadFormDataModal;
}(_react2.default.Component);

UploadFormDataModal.propTypes = {
  mediaUrl: PropTypes.string.isRequired,
  observationsUrl: PropTypes.string.isRequired,
  onCloseClick: PropTypes.func.isRequired
};


var mapStateToProps = function mapStateToProps(state) {
  return {
    mediaUrl: state.xformUploader.mediaUrl,
    observationsUrl: state.xformUploader.observationsUrl
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps)(UploadFormDataModal);