'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _filter_container = require('./filter_container');

var _filter_container2 = _interopRequireDefault(_filter_container);

var _top_bar = require('./top_bar');

var _top_bar2 = _interopRequireDefault(_top_bar);

var _action_creators = require('../action_creators');

var actionCreators = _interopRequireWildcard(_action_creators);

var _modal = require('../components/modal');

var _modal2 = _interopRequireDefault(_modal);

var _feature_detail = require('../components/feature_detail');

var _feature_detail2 = _interopRequireDefault(_feature_detail);

var _filter_configurator = require('../components/filter_configurator');

var _filter_configurator2 = _interopRequireDefault(_filter_configurator);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  outer: {
    position: 'fixed',
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    display: 'flex',
    flexDirection: 'column',
    fontFamily: 'Roboto, sans-serif',
    WebkitFontSmoothing: 'antialiased',
    fontSize: 15,
    lineHeight: '24px'
  },
  inner: {
    display: 'flex',
    flex: 1
  },
  addButton: {
    position: 'absolute',
    bottom: 36,
    right: 36,
    zIndex: 2
  }
};

var IndexRoute = function (_React$Component) {
  (0, _inherits3.default)(IndexRoute, _React$Component);

  function IndexRoute() {
    (0, _classCallCheck3.default)(this, IndexRoute);
    return (0, _possibleConstructorReturn3.default)(this, (IndexRoute.__proto__ || (0, _getPrototypeOf2.default)(IndexRoute)).apply(this, arguments));
  }

  (0, _createClass3.default)(IndexRoute, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.redirectIfNecessary(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.redirectIfNecessary(nextProps);
    }
  }, {
    key: 'redirectIfNecessary',
    value: function redirectIfNecessary(_ref) {
      var activeModal = _ref.activeModal,
          activeView = _ref.activeView,
          views = _ref.views,
          redirectView = _ref.redirectView;

      if (!(0, _find2.default)(views, { id: activeView })) return redirectView(views[0].id);
      if (activeModal && !getModalComponent(activeModal)) redirectView(activeView);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          activeView = _props.activeView,
          activeModal = _props.activeModal,
          AddButton = _props.addButton,
          views = _props.views,
          switchView = _props.switchView;

      var ModalComponent = getModalComponent(activeModal);
      var ViewComponent = getViewComponent(activeView, views);

      return _react2.default.createElement(
        'div',
        { className: 'outer container', style: styles.outer },
        _react2.default.createElement(_top_bar2.default, { views: views, activeView: activeView, onChangeTab: switchView }),
        _react2.default.createElement(
          'div',
          { className: 'inner container', style: styles.inner },
          _react2.default.createElement(_filter_container2.default, null),
          _react2.default.createElement(ViewComponent, null),
          AddButton && _react2.default.createElement(
            'div',
            { style: styles.addButton },
            _react2.default.createElement(AddButton, null)
          )
        ),
        _react2.default.createElement(_modal2.default, { component: ModalComponent })
      );
    }
  }]);
  return IndexRoute;
}(_react2.default.Component);

function getModalComponent(modal) {
  switch (modal) {
    case 'feature':
      return _feature_detail2.default;
    case 'settings':
      return _filter_configurator2.default;
    default:
      return;
  }
}

function getViewComponent(activeView, views) {
  var view = (0, _find2.default)(views, { id: activeView });
  if (!view) return function () {
    return _react2.default.createElement('div', null);
  };
  return view.component;
}

exports.default = (0, _reactRedux.connect)(function (state) {
  return state.ui || {};
}, function (dispatch) {
  return (0, _redux.bindActionCreators)(actionCreators, dispatch);
})(IndexRoute);