'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var _map_view = require('../components/map_view');

var _map_view2 = _interopRequireDefault(_map_view);

var _action_creators = require('../action_creators');

var _map_geojson = require('../selectors/map_geojson');

var _map_geojson2 = _interopRequireDefault(_map_geojson);

var _mapbox_filter = require('../selectors/mapbox_filter');

var _mapbox_filter2 = _interopRequireDefault(_mapbox_filter);

var _field_mapping = require('../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapStateToProps(state) {
  return {
    center: state.mapPosition.center,
    zoom: state.mapPosition.zoom,
    geojson: (0, _map_geojson2.default)(state),
    filter: (0, _mapbox_filter2.default)(state),
    fieldMapping: (0, _field_mapping2.default)(state)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    onMove: function onMove(mapPosition) {
      return dispatch((0, _action_creators.moveMap)(mapPosition));
    },
    onMarkerClick: function onMarkerClick(id) {
      return dispatch((0, _action_creators.showFeatureDetail)(id));
    }
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_map_view2.default);