'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _Paper = require('material-ui/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _insertCss = require('insert-css');

var _insertCss2 = _interopRequireDefault(_insertCss);

var _feature_detail = require('../components/feature_detail');

var _feature_detail2 = _interopRequireDefault(_feature_detail);

var _prop_types = require('../util/prop_types');

var MFPropTypes = _interopRequireWildcard(_prop_types);

var _map_view = require('../components/map_view');

var _map_view2 = _interopRequireDefault(_map_view);

var _alert = require('../components/alert');

var _alert2 = _interopRequireDefault(_alert);

var _field_mapping = require('../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

var _filtered_features = require('../selectors/filtered_features');

var _filtered_features2 = _interopRequireDefault(_filtered_features);

var _mapbox_filter = require('../selectors/mapbox_filter');

var _mapbox_filter2 = _interopRequireDefault(_mapbox_filter);

var _map_geojson = require('../selectors/map_geojson');

var _map_geojson2 = _interopRequireDefault(_map_geojson);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _insertCss2.default)('\n.report_wrapper {\n  overflow: scroll;\n}\n.report_container {\n  display: flex;\n  flex-grow: 1;\n  flex-wrap: wrap;\n  background-color: rgba(236, 236, 236, 1);\n  padding: 0 20px\n}\n.report_paper {\n  margin: 20px auto;\n  width: 8.5in;\n  min-height: 11in;\n  page-break-after: always;\n  background-color: initial;\n  position: relative;\n}\n.report_paper:last-child {\n  page-break-after: avoid !important;\n}\n.page_break {\n  position: absolute;\n  left: 0;\n  top: 11in;\n  width: 100%;\n  border: none;\n  margin: 0;\n  border-bottom: 3px dashed rgba(200,200,200, 0.75);\n}\n.report_page {\n  margin: 0.5in 0.5in 0.5in 0.5in;\n}\n.report_paper:first-child {\n  display: flex;\n}\n.report_paper:first-child .report_page {\n  flex: 1;\n  display: flex;\n  flex-direction: column;\n}\n@media only print {\n  body, html {\n    overflow: visible;\n  }\n  /* Override display: flex which breaks page-break-after */\n  .outer.container, .inner.container {\n    display: block !important;\n  }\n  /* Fix for page-break-after not working in Chrome see http://stackoverflow.com/questions/4884380/css-page-break-not-working-in-all-browsers/5314590 */\n  div {\n    float: none !important;\n  }\n  tr {\n    page-break-inside: avoid;\n  }\n  /* Override fixed positioning of top level div */\n  #root > div {\n    position: relative !important;\n  }\n  .report_container {\n    display: block;\n    padding: 0;\n    overflow: visible;\n    background-color: initial;\n  }\n  .report_paper {\n    box-shadow: none !important;\n    border-radius: 0 !important;\n    margin: 0;\n  }\n  .report_page {\n    margin: 0\n  }\n  /* TODO include some form of MapFilter header */\n  /* TODO rotate the filter display and show state vs. allow interaction */\n  .mapboxgl-control-container,\n  .nav.container,\n  .page_break,\n  .report_header,\n  .filter {\n    display: none !important;\n  }\n}\n');

var ReportContainer = function (_React$Component) {
  (0, _inherits3.default)(ReportContainer, _React$Component);

  function ReportContainer() {
    (0, _classCallCheck3.default)(this, ReportContainer);
    return (0, _possibleConstructorReturn3.default)(this, (ReportContainer.__proto__ || (0, _getPrototypeOf2.default)(ReportContainer)).apply(this, arguments));
  }

  (0, _createClass3.default)(ReportContainer, [{
    key: 'render',
    value: function render() {
      var features = this.props.features;

      var featuresSlice = features.length > 26 ? features.slice(0, 26) : features;

      return _react2.default.createElement(
        'div',
        { className: 'report_wrapper' },
        _react2.default.createElement(
          'div',
          { className: 'report_header' },
          features.length > 26 && _react2.default.createElement(_alert2.default, { label: 'Current filters show ' + features.length + ' records, a report will only show the first 26 records' })
        ),
        _react2.default.createElement(
          'div',
          { className: 'report_container' },
          _react2.default.createElement(
            _Paper2.default,
            { className: 'report_paper' },
            _react2.default.createElement(
              'div',
              { className: 'report_page' },
              _react2.default.createElement(
                'h2',
                null,
                featuresSlice.length,
                ' Observations'
              ),
              _react2.default.createElement(_map_view2.default, (0, _extends3.default)({}, this.props, {
                interactive: false,
                labelPoints: true
              }))
            )
          ),
          featuresSlice.map(function (feature, id) {
            return _react2.default.createElement(
              _Paper2.default,
              { className: 'report_paper', key: id },
              _react2.default.createElement(
                'div',
                { className: 'report_page' },
                _react2.default.createElement(_feature_detail2.default, {
                  key: id,
                  id: feature.id,
                  label: feature.properties.__mf_label,
                  print: true
                })
              ),
              _react2.default.createElement('hr', { className: 'page_break' })
            );
          }),
          featuresSlice.length > 20 && _react2.default.createElement(
            _Paper2.default,
            { className: 'report_paper' },
            _react2.default.createElement(
              'div',
              { className: 'report_page' },
              _react2.default.createElement(
                'h2',
                null,
                'Cannot print more than 26 observations in a single report'
              )
            )
          )
        )
      );
    }
  }]);
  return ReportContainer;
}(_react2.default.Component);

ReportContainer.propTypes = {
  features: _react.PropTypes.array.isRequired,
  fieldMapping: MFPropTypes.fieldMapping,
  filter: MFPropTypes.mapboxFilter,
  geojson: _react.PropTypes.shape({
    type: _react.PropTypes.oneOf(['FeatureCollection']).isRequired,
    features: _react.PropTypes.arrayOf(MFPropTypes.mapViewFeature).isRequired
  }).isRequired
};


function mapStateToProps(state) {
  return {
    features: (0, _filtered_features2.default)(state),
    fieldMapping: (0, _field_mapping2.default)(state),
    filter: (0, _mapbox_filter2.default)(state),
    geojson: (0, _map_geojson2.default)(state)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps)(ReportContainer);