'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _AppBar = require('material-ui/AppBar');

var _AppBar2 = _interopRequireDefault(_AppBar);

var _reactIntl = require('react-intl');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  topBar: {
    height: 56
  },
  title: {
    height: 56,
    lineHeight: '56px'
  },
  tabs: {
    flex: 1,
    maxWidth: 300,
    display: 'flex'
  },
  tab: {
    display: 'flex',
    flex: 1,
    fontFamily: 'Roboto, sans-serif',
    fontWeight: 400,
    color: 'rgba(255, 255, 255, 0.701961)',
    textDecoration: 'none',
    textTransform: 'uppercase',
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center',
    boxSizing: 'border-box',
    cursor: 'pointer'
  },
  activeTab: {
    color: 'rgba(255, 255, 255, 1)',
    fontWeight: 500,
    borderBottom: '2px solid rgb(255, 64, 129)',
    paddingTop: 2
  },
  right: {
    flex: 1
  }
};

var messages = (0, _reactIntl.defineMessages)({
  map: {
    'id': 'topbar.map',
    'defaultMessage': 'Map'
  },
  media: {
    'id': 'topbar.media',
    'defaultMessage': 'Media'
  },
  report: {
    'id': 'topbar.report',
    'defaultMessage': 'Report'
  }
});

function TopBar(_ref) {
  var activeView = _ref.activeView,
      views = _ref.views,
      onChangeTab = _ref.onChangeTab;

  return _react2.default.createElement(
    _AppBar2.default,
    {
      className: 'nav container',
      title: 'MapFilter',
      style: styles.topBar,
      titleStyle: styles.title,
      showMenuIconButton: false },
    _react2.default.createElement(
      'div',
      { style: styles.tabs },
      views.map(function (view) {
        var tabStyle = view.id === activeView ? (0, _objectAssign2.default)({}, styles.tab, styles.activeTab) : styles.tab;
        return _react2.default.createElement(
          'a',
          { key: view.id, style: tabStyle, onClick: onChangeTab.bind(null, view.id) },
          _react2.default.createElement(_reactIntl.FormattedMessage, messages[view.id])
        );
      })
    ),
    _react2.default.createElement('div', { style: styles.right })
  );
}

exports.default = TopBar;