'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _redboxReact = require('redbox-react');

var _redboxReact2 = _interopRequireDefault(_redboxReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MapFilter = require('./index').default;
var fs = require('fs');
var path = require('path');

var sampleGeoJSON = fs.readFileSync(path.join(__dirname, '../example/sample.geojson'), 'utf8');
var features = JSON.parse(sampleGeoJSON).features;

var rootEl = document.getElementById('root');

var render = function render() {
  _reactDom2.default.render(_react2.default.createElement(MapFilter, { features: features }), rootEl);
};

if (module.hot) {
  // Support hot reloading of components
  // and display an overlay for runtime errors
  var renderApp = render;
  var renderError = function renderError(error) {
    _reactDom2.default.render(_react2.default.createElement(_redboxReact2.default, { error: error }), rootEl);
  };
  render = function render() {
    try {
      renderApp();
    } catch (error) {
      renderError(error);
    }
  };
  module.hot.accept('./index', function () {
    setTimeout(render);
  });
}

render();