'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _reselect = require('reselect');

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _colored_field = require('./colored_field');

var _colored_field2 = _interopRequireDefault(_colored_field);

var _config = require('../../config.json');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getColorIndex = (0, _reselect.createSelector)(_colored_field2.default, _field_analysis2.default, function (coloredField, fieldStats) {
  var colorIndex = {};
  if (!coloredField) return colorIndex;
  var values = (0, _keys2.default)(fieldStats[coloredField].values);
  if (!values) return colorIndex;
  values.forEach(function (v, i) {
    colorIndex[v] = _config2.default.colors[i] || _config2.default.defaultColor;
  });
  return colorIndex;
});

exports.default = getColorIndex;