'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _reselect = require('reselect');

var _randombytes = require('randombytes');

var _randombytes2 = _interopRequireDefault(_randombytes);

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _id_fields = require('./id_fields');

var _id_fields2 = _interopRequireDefault(_id_fields);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function uniqueId() {
  return (0, _randombytes2.default)(8).toString('hex');
}

var getFeaturesWithIds = (0, _reselect.createSelector)(function (state) {
  return state.features;
}, _field_analysis2.default, _id_fields2.default, function (features, fieldAnalysis, idFieldNames) {
  return features.map(function (f) {
    // We use an existing id feature property, if it is unique across all features,
    // or we use any unique id field we find under properties, or, failing that,
    // we generate a unique id.
    var id = fieldAnalysis.__validGeoJsonIdField ? f.id : f.properties[idFieldNames[0]] || uniqueId();
    return (0, _assign2.default)({}, f, { id: id });
  });
});

exports.default = getFeaturesWithIds;