'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _union = require('lodash/union');

var _union2 = _interopRequireDefault(_union);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _reselect = require('reselect');

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _visible_filters = require('./visible_filters');

var _visible_filters2 = _interopRequireDefault(_visible_filters);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// We're only interested in filters that apply to keys that
// actually exist in our data
var getFilters = (0, _reselect.createSelector)(function (state) {
  return state.filters;
}, _field_analysis2.default, function (filters, fieldStats) {
  return (0, _pick2.default)(filters, (0, _keys2.default)(fieldStats));
});

// We should always show filters for any fields that
// are in the current filter
var getMergedFilterFields = (0, _reselect.createSelector)(_visible_filters2.default, getFilters, function (visibleFilters, filters) {
  return (0, _union2.default)(visibleFilters, (0, _keys2.default)(filters));
});

var getFilterProps = (0, _reselect.createSelector)(getFilters, _field_analysis2.default, getMergedFilterFields, function (filters, fieldStats, visibleFilters) {
  return {
    filters: filters,
    fieldStats: fieldStats,
    visibleFilters: visibleFilters
  };
});

exports.default = getFilterProps;