'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _flat = require('flat');

var _flat2 = _interopRequireDefault(_flat);

var _reselect = require('reselect');

var _features_with_ids = require('./features_with_ids');

var _features_with_ids2 = _interopRequireDefault(_features_with_ids);

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _id_fields = require('./id_fields');

var _id_fields2 = _interopRequireDefault(_id_fields);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function dateStringToNumber(dateString) {
  return +new Date(dateString);
}

var getFilterableFeatures = (0, _reselect.createSelector)(_features_with_ids2.default, _field_analysis2.default, _id_fields2.default, function (features, fieldAnalysis, idFieldNames) {
  return features.map(function (f) {
    // We can't filter nested objects or arrays, so we flatten feature properties
    var properties = (0, _flat2.default)(f.properties);
    // To filter dates we need to convert date strings to numbers
    (0, _keys2.default)(fieldAnalysis).filter(function (f) {
      return fieldAnalysis[f].type === _constants.FIELD_TYPES.DATE;
    }).forEach(function (f) {
      properties[f] = dateStringToNumber(properties[f]);
    });
    return (0, _assign2.default)({}, f, { properties: properties });
  });
});

exports.default = getFilterableFeatures;