'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reselect = require('reselect');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _features_by_id = require('./features_by_id');

var _features_by_id2 = _interopRequireDefault(_features_by_id);

var _filtered_features_raw = require('./filtered_features_raw');

var _filtered_features_raw2 = _interopRequireDefault(_filtered_features_raw);

var _color_index = require('./color_index');

var _color_index2 = _interopRequireDefault(_color_index);

var _colored_field = require('./colored_field');

var _colored_field2 = _interopRequireDefault(_colored_field);

var _config = require('../../config.json');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFilteredFeatures = (0, _reselect.createSelector)(_features_by_id2.default, _filtered_features_raw2.default, _colored_field2.default, _color_index2.default, function (featuresById, filteredFeatures, colorIndex, coloredField) {
  return filteredFeatures.map(function (f, i) {
    return (0, _objectAssign2.default)({}, featuresById[f.id], {
      __label: _config2.default.labelChars.charAt(i)
    });
  });
});

exports.default = getFilteredFeatures;