'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reselect = require('reselect');

var _flat = require('flat');

var _flat2 = _interopRequireDefault(_flat);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _features_with_ids = require('./features_with_ids');

var _features_with_ids2 = _interopRequireDefault(_features_with_ids);

var _color_index = require('./color_index');

var _color_index2 = _interopRequireDefault(_color_index);

var _colored_field = require('./colored_field');

var _colored_field2 = _interopRequireDefault(_colored_field);

var _config = require('../../config.json');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFlattenedFeatures = (0, _reselect.createSelector)(_features_with_ids2.default, _colored_field2.default, _color_index2.default, function (features, coloredField, colorIndex) {
  return features.map(function (f) {
    var newProps = (0, _flat2.default)(f.properties, { safe: true });
    var colorHex = void 0;
    if (coloredField) {
      var coloredFieldValue = newProps[coloredField];
      colorHex = Array.isArray(coloredFieldValue) ? colorIndex[coloredFieldValue[0]] : colorIndex[coloredFieldValue];
    }
    return (0, _objectAssign2.default)({}, f, {
      properties: newProps,
      __color: (colorHex || _config2.default.defaultColor).slice(1)
    });
  });
});

exports.default = getFlattenedFeatures;