'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reselect = require('reselect');

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Pick the id field that appears in most records
 */
var getIdFieldNames = (0, _reselect.createSelector)(_field_analysis2.default, function (fieldAnalysis) {
  var idFields = [];
  for (var fieldname in fieldAnalysis) {
    var field = fieldAnalysis[fieldname];
    if (field.isUnique) idFields.push(field.fieldname);
  }
  return idFields;
});

exports.default = getIdFieldNames;