'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _reselect = require('reselect');

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _filtered_features_raw = require('./filtered_features_raw');

var _filtered_features_raw2 = _interopRequireDefault(_filtered_features_raw);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getImageFieldNames = (0, _reselect.createSelector)(_field_analysis2.default, function (fieldAnalysis) {
  return (0, _keys2.default)(fieldAnalysis).filter(function (fieldname) {
    return fieldAnalysis[fieldname].type === _constants.FIELD_TYPES.IMAGE;
  });
});

var getImages = (0, _reselect.createSelector)(_filtered_features_raw2.default, getImageFieldNames, function (features, imageFieldNames) {
  return features.reduce(function (p, feature) {
    imageFieldNames.forEach(function (f) {
      if (feature.properties[f]) {
        p.push({
          url: feature.properties[f],
          featureId: feature.id
        });
      }
    });
    return p;
  }, []);
});

exports.default = getImages;