'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _reselect = require('reselect');

var _filterable_features = require('./filterable_features');

var _filterable_features2 = _interopRequireDefault(_filterable_features);

var _filtered_features_raw = require('./filtered_features_raw');

var _filtered_features_raw2 = _interopRequireDefault(_filtered_features_raw);

var _color_index = require('./color_index');

var _color_index2 = _interopRequireDefault(_color_index);

var _colored_field = require('./colored_field');

var _colored_field2 = _interopRequireDefault(_colored_field);

var _config = require('../../config.json');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getMapGeoJSON = (0, _reselect.createSelector)(_filterable_features2.default, _filtered_features_raw2.default, _colored_field2.default, _color_index2.default, function (features, filteredFeatures, coloredField, colorIndex) {
  return {
    type: 'FeatureCollection',
    features: features.map(function (feature) {
      var props = feature.properties;
      var colorHex = colorIndex[props[coloredField] || props[coloredField + '.0']];
      var newProps = (0, _assign2.default)({}, props, {
        __mf_id: feature.id,
        __mf_color: (colorHex || _config2.default.defaultColor).slice(1),
        __mf_label: _config2.default.labelChars.charAt(filteredFeatures.indexOf(feature))
      });
      return (0, _assign2.default)({}, feature, {
        properties: newProps
      });
    })
  };
});

exports.default = getMapGeoJSON;