'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reselect = require('reselect');

var _intersection = require('lodash/intersection');

var _intersection2 = _interopRequireDefault(_intersection);

var _best_fields = require('./best_fields');

var _best_fields2 = _interopRequireDefault(_best_fields);

var _field_analysis = require('./field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _filterable_fields = require('./filterable_fields');

var _filterable_fields2 = _interopRequireDefault(_filterable_fields);

var _date_field = require('./date_field');

var _date_field2 = _interopRequireDefault(_date_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * If we have not defined which fields to show filters for, make a best
 * guess by choosing the first date field we find, and the best filter
 * field (see `./best_field.js` for how this is guessed)
 */
var getVisibleFilters = (0, _reselect.createSelector)(function (state) {
  return state.visibleFilters;
}, _best_fields2.default, _date_field2.default, _filterable_fields2.default, function (visibleFilters, bestFilterFields, dateFieldName, filterableFields) {
  if (visibleFilters == null) {
    visibleFilters = [];
    if (dateFieldName) visibleFilters.push(dateFieldName);
    if (bestFilterFields[0]) visibleFilters.push(bestFilterFields[0].fieldname);

    return visibleFilters;
  }
  return (0, _intersection2.default)(visibleFilters, filterableFields);
});

exports.default = getVisibleFilters;